/************************* 
	Maxthon Start Page
	By Neo101
	Version 2.1.1
	6 January 2007
**************************/


var activeTab	= 0

var objXMLDOM 	= new Array()
var objXMLHTTP  = new Array()
var weatherDay = new Array()

var NUMBER_OF_FEEDS = arrRSS.length - 1
var NUMBER_OF_FEEDS_START = NUMBER_OF_FEEDS
var NUMBER_OF_FORECASTS = arrWeather.length - 1


setLanguage()
writeStyle()

window.onerror = function(message, url, line){
	var d 		= new Date()
	var date	= d.getHours()+':'+d.getMinutes()+':'+d.getSeconds()
	if(window.status.search(/Message/) != 0)
		window.status = 'Message: '+message+' Line: '+line+' URL: '+url+' Date: '+date
}


document.onkeydown = function() {
	if( (top.configVisible != null && configVisible == true) || event.keyCode < 65 || event.keyCode > 90 || event.altKey || event.ctrlKey){
		return
	}
	document.searchForm.q.focus()
}


document.onmousemove = function(){
	if(window.event == null){
		return
	}
	if(top.TOOLTIPS_LOADED != null){
		setMouseCoords()
	}
	if(top.SECURITY_ID != null && top.DRAG_DROP_LOADED != null){
		return checkDragDrop()
	}
}


window.onload = function(){
	writeTitle()
	if(PRELOAD_FEEDS_AND_WEATHER != 1){
		window.setTimeout('loadAllRSSFeeds()', DELAY_FEEDS_LOAD)
		window.setTimeout('loadAllForecasts()', DELAY_FEEDS_LOAD)
	}

	window.setTimeout('blurLinks()',1000)
	
	if(SHOW_FAVORITES == 1){
		createRecentList()
	}
	
	if(OPEN_LINKS_IN_NEW_WINDOW == 0) {
		setRecentListLinkTargets('')
	}
	
	document.searchForm.q.blur()
}


function writeStyle(){
	document.getElementById('stylesheet').href = 'style/' + STYLE
}


function setLanguage(){
	if(LANGUAGE != 'English.js'){
		document.getElementById('languageScript').src = 'language/' + LANGUAGE
		document.getElementById('settingsScript').src = 'settings.js' //needed to overwrite the default settings from the language file
	}
}


function writeTitle(){
	document.title = translate('MaxthonStartPage')
}


// -------------------------------------------  Search Bar ------------------------------------------- //


function clickTab(activeTabNumber, activeTab){
	var divTags	= document.getElementsByTagName("div");
	
	for(var i=0; i<divTags.length; i++){
		if(divTags[i].id.indexOf("tab") == 0){
			divTags[i].className = "unselected-tab";
		}
	}
	
	var activeTabObj 		= document.getElementById("tab"+activeTabNumber);
	activeTabObj.className 	= "selected-tab";
	top.activeTab	= activeTabNumber;
}


function doSearch(){
	try{
		var tip = translate('keyword')
		
		if(document.searchForm.q.value != "" && document.searchForm.q.value != tip){
			var searchString = arrSearch[activeTab][1]
			var keywords = /%nes/i.test(searchString) ? document.searchForm.q.value : encodeURIComponent(document.searchForm.q.value)
			if(searchString.search(/%s|%us|%nes/i) == -1)
				searchString += keywords
			else searchString = searchString.replace(/%s|%us|%nes/gi,keywords);
			
			if(OPEN_SEARCH_IN_NEW_WINDOW == 1){
				var linkElement = document.getElementById('linkInNewWindow')
				linkElement.href = searchString
				linkElement.click()
			} else {
				location.href = searchString
			}
		} else {
			document.searchForm.q.value = tip;
			document.searchForm.q.select();
		}
		return false;
	}
	catch(err){
		location.href = searchString
		return false;
	}
}


// -------------------------------------------  RSS  ------------------------------------------- //


function writeFeeds(){
	var text = '';
	if( USE_PINNED_RSS_FEED == 1 ) { //Only for Maxthon 1.5.1 or higher
		var pinnedFeeds = ''
		try{
			pinnedFeeds = external.max_getPersonal('startFeed')
		} catch(err){}
		var arrPinnedFeeds = pinnedFeeds.split('$,$');

		for(var i=0; i<arrPinnedFeeds.length; i++){
			var pos = arrPinnedFeeds[i].indexOf('=');
			if(pos>-1){
				var title = arrPinnedFeeds[i].substring(0,pos);
				var url = arrPinnedFeeds[i].substring(pos + 1, arrPinnedFeeds[i].length);
				if(url.indexOf("*")==0){
					url = url.substring(1, url.length);
				}
				arrRSS[NUMBER_OF_FEEDS++] = new Array(title, url)
			}
		}
	}
	for(var i=1; i<=NUMBER_OF_FEEDS; i++){
		text +=
			'<div id="rssDiv'+i+'" style="position:absolute;">'+
				'<div id="rss-list'+i+'" class="list">'+
					translate('loadingFeed') + unescape( arrRSS[(i-1)][0] )+
					'.....'+
				'</div>'+
			'</div>'
	}
	
	document.write(text)
}


function loadRSS(i){
	var feedArray = arrRSS[i];
	var div = document.getElementById('rss-list'+(i+1));
	if(div==null){
		return;
	}
	if(feedArray == null || feedArray == '') {
		div.style.display = 'none'
	}
	var feedUrl = feedArray[1]
	objXMLDOM[i] = new ActiveXObject("Microsoft.XMLDOM")
	objXMLDOM[i].onreadystatechange = 	function(){
											stateChange(i, div, objXMLDOM[i], arrRSS[i])
										}
	try{
		objXMLDOM[i].load(feedUrl);
	}
	catch(err){
		div.innerHTML = translate('feedErrorAcces') + '<br>' + err.description
	}
}


function stateChange(i, div, xmlObject, feedArray) {
	if(xmlObject.readyState != 4){ //Not fully loaded
		return;
	}
	var feedName = unescape( feedArray[0] );
	var feedURL = feedArray[2]
	if(feedName == ''){
		feedName = xmlObject.getElementsByTagName("title")[0].text
	}
	if(feedURL && feedURL != ''){
		var response = '<h4 class="h4">'+
							'<a href="'+feedURL+'" target="_blank">'+feedName+'</a>'+
						'<\/h4>'+
						'<ul>';
	}
	else var response	= '<h4>'+feedName+'<\/h4><ul>';
	
	var rssFeeds = new Array()
	
	var items = xmlObject.getElementsByTagName("item");
	if(items == null || items.length == 0) 
		items = xmlObject.getElementsByTagName("entry"); //For ATOM feeds

	if(items && items.length != 0 ){
		for(var j=0; j < items.length && j < eval(MAX_ITEMS_LENGTH); j++) {
			addFeedItem(items[j], rssFeeds)
		}
	}
	else{
		response += translate('feedErrorLoad')
	}
	
	response += writeFeedHtml( rssFeeds )
	
	div.innerHTML = response
}


function writeFeedHtml( array ){
	var response = ''
	var target = (OPEN_FEEDS_IN_NEW_WINDOW == 1) ? 'target=_blank' : ''
	
	for(var i=0; i<array.length ; i++){
		response += '<li>'+
						'<a href="'+ array[i].link +'" '+target+
							' onmouseover="showToolTip(\''+array[i].description+'\')" onmouseout="hideToolTip()">'+
								array[i].title +
						'<\/a>'+
					'<\/li>';
	}
	response += '<\/ul>'
	
	return response
}


function addFeedItem( item , array){
	var title = ''
	var link = ''
	var description = ''
	
	var nodes = item.childNodes
	
	for(var i=0; i < nodes.length; i++)  {
		var tagName = nodes(i).tagName
		var tagText = nodes(i).text
		if(tagName=='title'){
			title = replacer(tagText)
		}
		else if(tagName=='link') {
			if(tagText != ''){
				link = replacer(tagText)
			}
			else if( item.childNodes(i).getAttribute("rel") != 'service.edit'){
				link = item.childNodes(i).getAttribute("href") //For ATOM Feeds
			}
		} 
		else if(tagName && tagName.search(/description|content/) == 0){
			description = replacer(tagText)
		}
	}
	
	if(LIMIT_FEED_TITLE_LENGTH == 1 && title.length > MAX_TITLE_LENGTH){
		description = '[b]' + title + '[/b]<br><br>' + description
		title = title.substring(0,MAX_TITLE_LENGTH-2) + '..'
	}
	
	description = description.replace(/<br( \/)?>/g,'[br]').replace(/<.*?>/g,'') //remove HTML tags
	description = escape(description)
	
	
	if(title != '' && link != ''){
		array.push( new feedItem(title, link, description) )
	}
}


function feedItem(title, link, description){
	this.title = title
	this.link = link
	this.description = description
}


function replacer(s){
	return s.replace(/&amp;/g,'&').replace(/&quot;/g,'"');
}


function loadAllRSSFeeds(){
	for(var i=0; i<NUMBER_OF_FEEDS; i++){
		loadRSS(i)
	}
}


// -------------------------------------------  Weather Bar ------------------------------------------- //


function writeWeather(){
	var text = '';
	for(var i=1; i<=NUMBER_OF_FORECASTS; i++){
		text +=
			'<div id="weatherDiv'+i+'" style="position:absolute">'+
				'<div id="weatherDataDiv" class="weather-main">'+
					'<h4>'+
						translate('WeatherLoading')+
					'</h4>'+
				'</div>'+
			'</div>'
	}
	document.write(text)
}


function loadAllForecasts(){
	for(var i=1; i<=NUMBER_OF_FORECASTS; i++){
		loadWeather(i)
	}
}


function loadWeather(i){
	var WEBPAGE_FUT = 'http://www.weather.com/weather/mpdwcr/tenday?locid='
	openConnection(WEBPAGE_FUT, i)
}


function openConnection(url, i) {
	var url = url + arrWeather[i-1][1]
	try{
		objXMLHTTP[i] = new ActiveXObject("Microsoft.XMLHTTP")
		objXMLHTTP[i].open("GET", url, true);
		objXMLHTTP[i].onreadystatechange = function(){getHTML(i)}
		objXMLHTTP[i].send();
	} catch(err){
		evaluate(0, i, err.description) 
	}
}


function evaluate(data, i, message){
	if(data == 0){
		document.getElementById('weatherDiv'+i).innerHTML = translate('feedErrorLoad') + ' ' + message
		return
	}
	evaluateFuture(data, i)
}


function getHTML(i){
	var xmlObject = objXMLHTTP[i]
	if(xmlObject && xmlObject.readyState == 4) {
		if(xmlObject.status == 200) {
			evaluate(xmlObject.responseText, i)
		}
		else {
			evaluate(0, i)
		}
	}
}


function evaluateFuture(data, num){
	var data = data.split('\n')
	var a = 0
	weatherDay[num] = new Array()
	
	for(var i=0; i<data.length; i++){
		var line = data[i]
		if(line.search(/new mpdFDObj\(new Date\(/) != -1) {
			eval( line.replace(/mpdData\['dayf'\].day\[([0-9])\]/i,'weatherDay[num][$1]') )
			a++
			if(a==10) break;
		} /*else if(line.search(/new mpdLocObj/) != -1) {
			var loc = line.replace(/.*?new mpdLocObj\((.*)/i,'$1')
			var split = loc.split(',')
			var location = (split[3]+', '+split[4]).replace(/'/g,'')
		} */
		else if(line.search(/new mpdHeadObj/) != -1){
			futureUnits = line.replace(/.*?new mpdHeadObj\('(.)'.*/i,'$1').replace(/C/i,'Celcius').replace(/F/i,'Fahrenheit')
		}
	}
	var location = unescape(arrWeather[num-1][0])
	document.getElementById('weatherDiv'+num).innerHTML = createBigTable(num, location)
}


function mpdFDObj(date, day, temp, lowTemp, uv, icon, text, windSpeed, windDirection, windDirShort, precip, humidity) {
	var object = new WeatherObject( temp, icon, text, 'Future', 2 )
	object.lowTemp = convertTemp(lowTemp, 'Future')
	//object.precip = quantity('Precip', 'notAlways') + precip + precipUnit
	
	var dayArray = ['Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday']
	object.date = translate( dayArray[ date.getDay() ])
	
	//object.uv = uv
	//object.wind = quantity('Wind', 'notAlways') + convertWind(windSpeed, 'Future') + ' ' + translateWind(windDirShort, true)
	//object.humid = quantity('Humid') + humidity + humidUnit
	return object
}


function WeatherObject( temp, icon, text, type, showQuantity ){
	this.temp = convertTemp(temp, type)
	var iconLocation = 'images/'
	var iconExtension = '.gif'
	this.icon = iconLocation + icon + iconExtension
	this.text = translate(text)
}


function createBigTable(num, location){
	var result = '<div id="weatherDataDiv" class="weather-main">'+
					'<h4>'+
						translate('weatherFor') + ' '+ transLocation(location)
					'</h4>'+
				'</div>'
	var element, length, elementArray, start
	
	var template = '<div class=weather-data>'+
					'[[date]]<br />'+
						'<img alt="[[iconAlt]]" src="[[icon]]" onerror="this.style.display=\'none\'"><br />'+
					'[[mainData]]'+
				'</div>'
	
	elementArray = weatherDay[num]

	if(elementArray == undefined || elementArray.length == 0){
		return translate('weatherError')
	}
	
	for(var i=0; i<NUMBER_OF_FORECAST_DAYS; i++){
		try{
			var element = elementArray[i]
			var date = element.date
			var icon = element.icon
			if( element.temp.search(/NaN/)!=-1 )
				var mainData = translate('low') + ': '+ element.lowTemp 
			else
				var mainData = '<b>' + element.temp + '</b> / ' + element.lowTemp 
			var iconAlt = element.text
			
			tablePart = template
			tablePart = tablePart.replace(/\[\[icon\]\]/, icon)
			tablePart = tablePart.replace(/\[\[iconAlt\]\]/, iconAlt)
			tablePart = tablePart.replace(/\[\[date\]\]/, date)
			tablePart = tablePart.replace(/\[\[mainData\]\]/, mainData)
			result += tablePart
		}
		catch(err){
			alert(err.description)
		}
	}
	return result
}


function convertTemp(value, type){
	var newValue
	
	if( toMetricSystem(type) ){ //Fahrenheit -> Celcius
		newValue = (5/9) * (value-32)
	}
	else if( fromMetricSystem(type) ){ //Celcius -> Fahrenheit
		newValue = (value*1.8) + 32
	} else { //Do not convert anything!
		newValue = value
	}

	return Math.round(newValue) + '&deg;' + ( (UNITS == 1) ? 'C' : 'F' )
}


function toMetricSystem(type){
	return ( UNITS == 1 && (type == 'Future' && futureUnits == 'Fahrenheit') )
}


function fromMetricSystem(type){
	return ( UNITS == 0 && (type == 'Future' && futureUnits == 'Celcius')  )
}


// -------------------------------------------  Load Settings ------------------------------------------- //


function loadFloat(){ //For old plugins
	onSecurityIDLoad()
}


function onSecurityIDLoad(){
	if(top.SECURITY_ID == null){
		alert('Security ID undefined!')
		return
	} else if(pluginButtonClick){
		setVisible('configurationDiv')
		
		document.getElementById('DragDropScript').src = 'script/DragDrop.js'
		document.getElementById('ConfigurationScript').src = 'script/Configuration.js'
		
		allFloatElements = []
		if(DISABLE_DRAG_DROP != 1){
			for(var i=1; i<=NUMBER_OF_FEEDS; i++) {
				allFloatElements.push('rssDiv'+i)
			}
			for(var i=1; i<=NUMBER_OF_FORECASTS; i++) {
				allFloatElements.push('weatherDiv'+i)
			}
			if(SHOW_IMPORTANT_LINKS == 1){
				allFloatElements.push('importantLinksDiv')
			}
			allFloatElements.push('searchDiv','recentDiv','aboutDiv','headerDiv','configurationMainDiv','configurationDiv')
			setPositions(allFloatElements)
			startDragDrop(allFloatElements)
		}
	}
}


// -------------------------------------------  Other Functions  ------------------------------------------- //


function createRecentList(){
	var recentListElement = document.getElementById('recentListUL');
	
	var favorites = ''
	try{
		favorites = external.max_getPersonal('hotfav')
	} catch(err){
		try{
			var arrString = external.max_readConfig("dynamic", "LastURL", "");
			var recentArray = arrString.split("$|$");
		}catch(err){
			recentListElement.innerHTML = translate('noFavorites');
			recentListElement.parentElement.heigth = "50px";
			recentListElement.parentElement.className = "list-small";
			return
		}
	}
	
	var html = ''
	var target = OPEN_LINKS_IN_NEW_WINDOW == 0 ? '' : 'target="_blank"'
	if(favorites != ''){
		var arrFavorites = favorites.split('$,$');

		for(var i=0; i<arrFavorites.length && i<NUMBER_OF_FAVORITES; i++){
			var pos = arrFavorites[i].indexOf('=');
			if(pos>-1){
				var name = arrFavorites[i].substring(0,pos);
				if(LIMIT_FEED_TITLE_LENGTH == 1){
					if(name.length > MAX_TITLE_LENGTH){
						name = name.substring(0,MAX_TITLE_LENGTH-2) + '...'
					}
				}
				var url = arrFavorites[i].substring(pos + 1, arrFavorites[i].length);
				html += '<li><a href="' + url + '" ' + target + '>' + name + '</a></li>'
			}
		}
	} else if(recentArray){

		for(var i=0; i<recentArray.length && i<NUMBER_OF_FAVORITES; i++){
			if(recentArray[i] == '') continue
			var recentUrl = recentArray[i].split('$,$');
			var name = recentUrl[0]
			if(LIMIT_FEED_TITLE_LENGTH == 1){
				if(name.length > MAX_TITLE_LENGTH){
					name = name.substring(0,MAX_TITLE_LENGTH-2) + '...'
				}
			}
			var url = recentUrl[1]
			if(url.match(/file:.*?start.htm/) == null){
				html += '<li><a href="' + url + '" ' + target + '>' + name + '</a></li>'
			}
		}
	}

	
	/*for(var i=0; i<recentListId.childNodes.length; i++){
		var node = recentListId.childNodes[i]
		if( node.childNodes(0).innerText.length > 43){
			node.childNodes(0).innerText = node.childNodes(0).innerText.substring(0,41) + '...'
		}
	}*/
	
	recentListElement.innerHTML = html
}


function setRecentListLinkTargets(target){
	for(var i=0; i < recentListId.childNodes.length; i++){
		recentListId.childNodes[i].childNodes(0).target = target;
	}
}


function blurLinks(){
	//Blur all links when you click on them, makes everything a bit nicer.
	var allLinks = document.getElementsByTagName('a')
	for(var i=0; i<allLinks.length; i++){
		allLinks[i].onfocus=function(){
			this.blur()
		}
	}
}


function checkBrowser(){
	var userAgent = window.navigator.userAgent;
	if(userAgent.search(/firefox|opera/i)!=-1) {
		write('onlyForMaxthon')
		NUMBER_OF_FEEDS = 0;
		NUMBER_OF_FORECASTS = 0;
	}
}


function setSearchButton(){
	document.getElementById('searchSubmitButton').value = translate('Search')
}


function preloadFeedsWeather(){
	if(PRELOAD_FEEDS_AND_WEATHER != 1){
		return
	}
	loadAllRSSFeeds()
	loadAllForecasts()
}


function setInvisible( elementID ){
	document.getElementById( elementID ).style.display = 'none'
}


function setVisible( elementID ){
	document.getElementById( elementID ).style.display = 'block'
}


function setDivsInvisible(){
	if(SHOW_MAXTHON_LINKS != 1)
		setInvisible('aboutDiv')
	if(SHOW_TITLE != 1)
		setInvisible('headerDiv')
	if(SHOW_FAVORITES == 0)
		setInvisible('recentDiv')
}


// -------------------------------------------  Write Functions  ------------------------------------------- //


function writeSearchLinks(){
	var result = "";
	for(var i=0; i<arrSearch.length-1; i++){
		result += '<div id="tab'+i+'" class="unselected-tab">'+
					'<span onclick="clickTab('+i+')" class="search-tab">'+
						unescape( arrSearch[i][0] )+
					'</span>'+
				  '</div>';
	}
	document.write(result);
}


function writeMaxthonLinks(){
	html = ''
	for(var i=0; i<maxthonLinks.length-1;i++){
		if(i != 0){
			html += ' | '
		}
		html += '<a href="'+maxthonLinks[i][0]+'" target="_blank">'+maxthonLinks[i][1]+'</a>'
	}
	document.write(html)
}


function writeImportantLinks(x){
	if(SHOW_IMPORTANT_LINKS == 0) {
		document.getElementById('important-links').style.display = 'none'
		return;
	}
	var text = '<ul>';
	
	for(var i=0; i<arrLinks.length-1; i++){
		text+='<li>'+
				'<a href="'+arrLinks[i][1]+'" '+((OPEN_LINKS_IN_NEW_WINDOW == 1)?'target=_blank':'')+'>'+
					unescape(arrLinks[i][0])+
				'</a>'+
			  '</li>';
	}
	text+='<\/ul>';
	
	document.write(text);
}


// -------------------------------------------  Translation  ------------------------------------------- //


function write( text ){
	document.write( translate( text ) )
}


function translate( text ){
	var result = language[text]
	if(result == null){
		result = language[ text.toLowerCase() ]
	}
	if(result == null){
		result = text
	}
	return result
}


function transLocation(location){
	try{
		var country			= location.split(',')[1].replace(/^ | $/,'')
		var countryTransl	= translate(country)
		var city			= location.split(',')[0].replace(/^ | $/,'')
		var cityTransl		= translate(city)
		if(countryTransl !='' && countryTransl != country) 
			location = location.replace(country,' '+countryTransl)
		if(cityTransl !='' && cityTransl != city) 
			location = location.replace(city,' '+cityTransl)
	}
	catch(err){
		alert(err.description)
	}
	
	return location
}